apiVersion: v1
kind: Template
objects:
  - apiVersion: apps.openshift.io/v1
    kind: DeploymentConfig
    metadata:
      labels:
        app: jenkins
      name: jenkins-dc
      namespace: ${NAMESPACE}
      selfLink: >-
        /apis/apps.openshift.io/v1/namespaces/${NAMESPACE}/deploymentconfigs/jenkins
    spec:
      replicas: 1
      selector:
        app: jenkins
        deploymentconfig: jenkins-dc
      strategy:
        activeDeadlineSeconds: 21600
        recreateParams:
          timeoutSeconds: 600
        resources: {}
        type: Recreate
      template:
        metadata:
          labels:
            app: jenkins
            deploymentconfig: jenkins-dc
        spec:
          containers:
            - image: >-
                gitlab-registry.cern.ch/industrial-controls/sw-infra/jenkins/master-fes:${IMAGE_VERSION}
              imagePullPolicy: IfNotPresent
              name: jenkins
              livenessProbe:
                failureThreshold: 5
                httpGet:
                  path: /login
                  port: 8080
                  scheme: HTTP
                initialDelaySeconds: 180
                periodSeconds: 120
                successThreshold: 1
                timeoutSeconds: 45
              readinessProbe:
                failureThreshold: 5
                httpGet:
                  path: /
                  port: 8080
                  scheme: HTTP
                initialDelaySeconds: 240
                periodSeconds: 15
                successThreshold: 1
                timeoutSeconds: 30
              envFrom:
                - secretRef:
                    name: ci4fes
                - configMapRef:
                    name: env-config
              env:
                - name: JENKINS_URL
                  value: https://${NAMESPACE}.web.cern.ch
                - name: JENKINS_SLAVE_AGENT_PORT
                  value: "5000"
              ports:
                - containerPort: 8080
                  protocol: TCP
              resources: 
                requests:
                  cpu: 2500m
                  memory: 4096Mi
                limits:
                  cpu: 3600m
                  memory: 7096Mi
              terminationMessagePath: /dev/termination-log
              terminationMessagePolicy: File
              volumeMounts:
                - mountPath: /secrets
                  name: secrets-volume
                  readOnly: true
                - mountPath: /var/lib/jenkins/casc_configs
                  name: casc-volume
                  readOnly: true
                - mountPath: /var/jenkins_home
                  name: jenkins-home-volume
          dnsPolicy: ClusterFirst
          restartPolicy: Always
          schedulerName: default-scheduler
          securityContext: { }
          terminationGracePeriodSeconds: 30
          volumes:
            - name: secrets-volume
              secret:
                secretName: ci4fes-ssh
            - name: casc-volume
              configMap:
                name: casc-config
            - name: jenkins-home-volume
              persistentVolumeClaim:
                claimName: jenkins-home-pvc

  - 
    kind: PersistentVolumeClaim
    apiVersion: v1
    metadata:
      name: jenkins-home-pvc
      labels:
        app: jenkins
    spec:
      accessModes:
        - ReadWriteOnce
      resources:
        requests:
          storage: 80Gi
parameters:
  - name: IMAGE_VERSION
    description: Image tag to deploy
    required: true
  - name: NAMESPACE
    description: Jenkins instance namespace (hostname)
    required: true


